
from lxml import etree
from odoo.upgrade import util

def migrate(cr, version):

    util.remove_view(cr, "openerp_website.o_day23_remove_event_nav")
    util.remove_view(cr, "openerp_website.o_xp23_remove_event_nav")

    # cannot use update_record_from_xml as those are only in demo datas,
    # instead directly patch the view
    for view_xmlid, event_xmlid, event_varname in (
        ("openerp_website.o_xp23_layout", "openerp_website.event_oxp23", "event_oxp23"),
        ("openerp_website.o_day23_layout", "openerp_website.event_odooday23", "event_odooday23"),
    ):
        with util.skippable_cm(), util.edit_view(cr, xmlid=view_xmlid) as arch:
            for n in arch.xpath("//xpath[contains(@expr, 'wrap') and @position = 'before']"):
                n.getparent().replace(n, etree.fromstring(f"""
                    <xpath expr="//*[@id='wrap']" position="before">
                        <t t-set="{event_varname}" t-value="request.env.ref('{event_xmlid}', False)"/>
                        <t t-if="event and {event_varname} and event == {event_varname}">
                            <t t-set="hide_submenu" t-value="True"/>
                        </t>
                        <t t-else="" t-set="{event_varname}" t-value=""/>
                    </xpath>
                """))

    with util.skippable_cm(), util.edit_view(cr, "openerp_website.o_day23_event_booth_registration") as arch:
        for node in arch.xpath("//*[@t-att-data-price]"):
            attr_val = node.get("t-att-data-price")
            attr_val.replace(".get_current_pricelist()", ".pricelist_id")
            node.set("t-att-data-price", attr_val)

    # patch or remove view from older OXP that don't work after website_event redesign
    with util.skippable_cm(), util.edit_view(cr, "openerp_website.oxp22_event_registration_description") as arch:
        for node in arch.xpath("//xpath"):
            if (node.get("expr") or "") == "//section[hasclass('mt-n5')]":
                node.set("expr", "//section[hasclass('h-100')]")
    # remove broken register bar, we don't need to register on those old event anyway
    util.remove_view(cr, "openerp_website.oxp22_event_registration_bar")
    util.remove_view(cr, view_id=14154)  # Header OXP - 2020 (TFR)
